#version 330 core
layout(location = 0) in vec3 in_vertex;
layout(location = 1) in vec3 in_normal;
layout(location = 2) in vec2 in_texcoord;
layout(location = 3) in mat4 instanceMatrix;

uniform mat4 view;
uniform mat4 projection;

out vec3 normal;
out vec3 position;
out vec2 texcoord;

void main(){
	position = vec3(instanceMatrix * vec4(in_vertex, 1.0));
	normal = mat3(transpose(inverse(instanceMatrix))) * in_normal;
	texcoord = in_texcoord;
	
	gl_Position = projection * view * instanceMatrix * vec4(position, 1.0);
}